/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2008 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: EjbBC.java ofabre$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.bc.ejb.listener;

import java.util.logging.Level;

import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;

import org.ow2.petals.component.framework.listener.AbstractJBIListener;
import org.ow2.petals.component.framework.api.exception.PEtALSCDKException;
import org.ow2.petals.component.framework.api.message.Exchange;

/**
 * 
 * @author ofabre -eBM Websourcing
 */
public class JBIListener extends AbstractJBIListener {

	/**
	 *
	 */
	private FaultManager faultManager;

	/**
	 *
	 */
	private ResponseManager responseManager;

	/**
	 *
	 */
	private ServiceManager serviceManager;

	/**
	 *
	 */
	@Override
	protected void init() {
		// Create ServiceManager, ResponseManager and FaultManager here
		faultManager = new FaultManager(this);
		responseManager = new ResponseManager(this);
		serviceManager = new ServiceManager(this);
	}

	/**
	 * 
	 * @param exchange
	 */
	@Override
	protected void onJBIMessage(Exchange exchange) {
		getLogger().log(Level.FINE, "onJBIMessage");
		try {
			if (exchange.isActiveStatus()) {
				if (exchange.getFault() != null) {
					faultManager.onJBIMessage(exchange);
				} else if (MessageExchange.Role.CONSUMER.equals(exchange
						.getRole())) {
					responseManager.onJBIMessage(exchange);
				} else {
					serviceManager.onJBIMessage(exchange);
				}
			}
		} catch (PEtALSCDKException e) {
			getLogger().log(Level.SEVERE, e.getMessage(), e);
			try {
				exchange.setFault(e);
			} catch (MessagingException e1) {
				exchange.setError(e1);
			}
		}
	}

}